/**********************************************************************
Eternal Story on Temporary Objects

Dmitri Korotkevitch
http://aboutsqlserver.com
dmitri@aboutsqlserver.com

07. Version Store
**********************************************************************/
set nocount on
go

use [24HOP_2014]
go

/* Triggers */
/* Just for fun */
select index_level, page_count, avg_fragmentation_in_percent, avg_page_space_used_in_percent, record_count
from sys.dm_db_index_physical_stats(db_id(),object_id(N'dbo.Orders'),1,null,'detailed');
go

create trigger trg_Orders_AD on dbo.Orders
after delete
as
	return
go

begin tran
	delete from dbo.Orders
	where OrderId % 2 = 0
	select count(*) from orders

select index_level, page_count, avg_fragmentation_in_percent, avg_page_space_used_in_percent, record_count
from sys.dm_db_index_physical_stats(db_id(),object_id(N'dbo.Orders'),1,null,'detailed');

rollback
go

drop trigger trg_Orders_AD
go




/* Optimistic Isolation Levels */
alter database [24HOP_2014] set read_committed_snapshot on with rollback immediate
go

-- Start Perf Mon (Version Store perf counters)
set transaction isolation level read uncommitted
begin tran
	delete from dbo.Orders
	where OrderId % 2 = 0

rollback
go

alter database [24HOP_2014] set read_committed_snapshot off with rollback immediate

