/**********************************************************************
Eternal Story on Temporary Objects

Dmitri Korotkevitch
http://aboutsqlserver.com
dmitri@aboutsqlserver.com

08. Temporary object caching
**********************************************************************/
set nocount on
go

use tempdb
go

if exists
(
	select * 
	from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id
	where p.name = 'TempTableCaching' and s.name = 'dbo'
)
	drop proc dbo.TempTableCaching
go

create proc dbo.TempTableCaching
as
	create table #T(C int not null primary key)
	drop table #T 
go

checkpoint
go

exec dbo.TempTableCaching
go

select Operation, Context, AllocUnitName, [Transaction Name], [Description]
from sys.fn_dblog(null, null)
go




alter proc dbo.TempTableCaching
as
	create table #T(C int not null)
	
	alter table #T add C2 int null
	
	drop table #T 
go